package com.sun.corba.se.impl.dynamicany;

import org.omg.DynamicAny.DynAnyPackage.TypeMismatch;
import org.omg.DynamicAny.DynAny;
import org.omg.DynamicAny.DynAnyPackage.InvalidValue;
import org.omg.CORBA.TypeCodePackage.BadKind;
import org.omg.DynamicAny.DynAnyFactoryPackage.InconsistentTypeCode;
import org.omg.CORBA.TypeCode;
import com.sun.corba.se.spi.orb.ORB;
import org.omg.CORBA.Any;

abstract class DynAnyCollectionImpl extends DynAnyConstructedImpl
{
    Any[] anys;
    
    private DynAnyCollectionImpl() {
        this(null, (Any)null, false);
    }
    
    protected DynAnyCollectionImpl(ORB orb, Any any, boolean b) {
        super(orb, any, b);
        this.anys = null;
    }
    
    protected DynAnyCollectionImpl(ORB orb, TypeCode typeCode) {
        super(orb, typeCode);
        this.anys = null;
    }
    
    protected void createDefaultComponentAt(int n, TypeCode typeCode) {
        try {
            this.components[n] = DynAnyUtil.createMostDerivedDynAny(typeCode, this.orb);
        }
        catch (InconsistentTypeCode inconsistentTypeCode) {}
        this.anys[n] = this.getAny(this.components[n]);
    }
    
    protected TypeCode getContentType() {
        try {
            return this.any.type().content_type();
        }
        catch (BadKind badKind) {
            return null;
        }
    }
    
    protected int getBound() {
        try {
            return this.any.type().length();
        }
        catch (BadKind badKind) {
            return 0;
        }
    }
    
    public Any[] get_elements() {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        return this.checkInitComponents() ? this.anys : null;
    }
    
    protected abstract void checkValue(Object[] p0) throws InvalidValue;
    
    public void set_elements(Any[] anys) throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        this.checkValue(anys);
        this.components = new DynAny[anys.length];
        this.anys = anys;
        TypeCode contentType = this.getContentType();
        int i = 0;
        while (i < anys.length) {
            if (anys[i] != null) {
                if (!anys[i].type().equal(contentType)) {
                    this.clearData();
                    throw new TypeMismatch();
                }
                try {
                    this.components[i] = DynAnyUtil.createMostDerivedDynAny(anys[i], this.orb, false);
                }
                catch (InconsistentTypeCode inconsistentTypeCode) {
                    throw new InvalidValue();
                }
                ++i;
            }
            else {
                this.clearData();
                throw new InvalidValue();
            }
        }
        this.index = ((anys.length == 0) ? -1 : 0);
        this.representations = 4;
        return;
    }
    
    public DynAny[] get_elements_as_dyn_any() {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        return this.checkInitComponents() ? this.components : null;
    }
    
    public void set_elements_as_dyn_any(DynAny[] array) throws TypeMismatch, InvalidValue {
        if (this.status == 2) {
            throw this.wrapper.dynAnyDestroyed();
        }
        this.checkValue(array);
        this.components = ((array == null) ? DynAnyCollectionImpl.emptyComponents : array);
        this.anys = new Any[array.length];
        TypeCode contentType = this.getContentType();
        int i = 0;
        while (i < array.length) {
            if (array[i] != null) {
                if (!array[i].type().equal(contentType)) {
                    this.clearData();
                    throw new TypeMismatch();
                }
                this.anys[i] = this.getAny(array[i]);
                ++i;
            }
            else {
                this.clearData();
                throw new InvalidValue();
            }
        }
        this.index = ((array.length == 0) ? -1 : 0);
        this.representations = 4;
        return;
    }
}
